var httpRequest;
var lastID;

function ham(id) {
    if (window.XMLHttpRequest) { // Mozilla, Safari, Opera, IE7
        httpRequest = new XMLHttpRequest();
    } else if (window.ActiveXObject) { // IE6, IE5
        httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
    }

    httpRequest.onreadystatechange = setMessage; // Callback Function
    lastID = id;
    // Method, url, Async = true / Sync = false
    httpRequest.open('POST', learncommentPath, true);
    httpRequest.setRequestHeader('content-Type', 'application/x-www-form-urlencoded; charset='+bayesCharset);
    httpRequest.send('id='+id+'&category=ham'); // Start request
    setLoadIndicator(id);
}

function spam(id) {
    if (window.XMLHttpRequest) { // Mozilla, Safari, Opera, IE7
        httpRequest = new XMLHttpRequest();
    } else if (window.ActiveXObject) { // IE6, IE5
        httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
    }

    httpRequest.onreadystatechange = deleteComment;
    lastID = id;
    httpRequest.open('POST', learncommentPath, true);
    httpRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset='+bayesCharset);
    httpRequest.send('id='+id+'&category=spam'); // Start request
    setLoadIndicator(id);
}

function setLoadIndicator(id) {
    var imgElement = document.createElement("img");
    imgElement.src=bayesLoadIndicator;
    document.getElementById('comment_'+id).appendChild(imgElement);
}

function setMessage() {
    if (httpRequest.readyState == 4 && httpRequest.status == 200) {
        var textElement = document.createElement("p");
        textElement.appendChild(document.createTextNode(bayesDone));
        //update ratings to make the effect visible
        getAllRatings();
        //remove load-indicator:
        var comment = document.getElementById('comment_'+lastID);
        comment.removeChild(comment.lastChild);
        comment.appendChild(textElement);
    }
}

function deleteComment() {
    if (httpRequest.readyState == 4 && httpRequest.status == 200) {
        getAllRatings();
        var comment = document.getElementById('comment_'+lastID);
        comment.parentNode.removeChild(comment);
        //delete moderation-message if existing
        message = document.getElementsByName('c'+lastID)[0];
        message = message.parentNode;
        message.parentNode.removeChild(message);
        
    }
}

/*Rating-display*/

function getRating(id)  {
    var httpRequest;
    if (window.XMLHttpRequest) { // Mozilla, Safari, Opera, IE7
        httpRequest = new XMLHttpRequest();
    } else if (window.ActiveXObject) { // IE6, IE5
        httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
    }

    //define the callback here to make it possible to have a local httpRequest
    //which is needed for the multiple requests we are sending
    httpRequest.onreadystatechange = function() {
        if (httpRequest.readyState == 4 && httpRequest.status == 200) {
            var response = httpRequest.responseText.split(';');
            var length = response.length;
            for (var i=0; i < length; i=i+2) {
                updateRating(response[i+1], response[i]);
            }
            //httpRequest.abort();
        }
    }
    httpRequest.open('POST', ratingPath, true);
    httpRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset='+bayesCharset);

    //fetch all ratings of all ids in one step to be faster
    if (id.constructor == Array) {
        id = id.join(';');
    }
    httpRequest.send('id='+id); // Start request
}

function updateRating(id, rating) {
    var ratingElement = document.getElementById(id+'_rating');
    if (ratingElement != null) {
        ratingElement.innerHTML = rating;
    } else {
        var textElement = document.createElement('span');
        textElement.setAttribute('class', 'spamblockBayesRating');
        ratingElement = document.createElement('span');
        ratingElement.setAttribute('id', id+'_rating');
        ratingElement.appendChild(document.createTextNode(rating));
        textElement.appendChild(ratingElement);
        var help = document.createElement('img');
        help.setAttribute('src', bayesHelpImage);
        textElement.setAttribute('title', bayesHelpTitle);
        textElement.appendChild(help);
        //id_mail only will exist in s9y 1.6
        var ratingLocation = document.getElementById(id+'_mail');
        if (ratingLocation == null) {
            ratingLocation = document.getElementById('comment_'+id);
        }
        ratingLocation.appendChild(textElement);
    }
}

function removeRatings() {
    //reduce number of searched elements via expensive getElementByClass
    var form = document.getElementById('formMultiDelete');
    var ratings = getElementByClass('spamblockBayesRating', form);
    length = ratings.length
    for (var i=0; i < length; i++) {
         ratings[i].parentNode.removeChild(ratings[i]);
    }
}

function getAllRatings() {
    var form = document.getElementById('formMultiDelete');
    //We need them to fetch the comment-ids
    var controls = getElementByClass('spamblockBayesControls', form, 'a');
    var length = controls.length;
    var ids = new Array()
    for (var i=0; i < length; i++) {
        if (controls[i].getAttribute('id').indexOf('spam') != -1) {
            ids.push(controls[i].getAttribute('id').replace('spam', ''));
        }
    }
    length = ids.length;
    //giving 10000s of comments to classify() will probably 
    //produce a timeout - so split it in smaller pieces
    var size = 100;
    var blocks = Math.ceil(length / size);
    for (i=0; i < blocks; i++) {
        getRating(ids.slice(i*size, (i*size)+size));
    }
}

//Something like this don't exist in Javascript
function getElementByClass(class, node, tag) {
    if (node == null) {
        node = document;
    }
    if (tag == null) {
        tag = "*";
    }
    var allHTMLTags = node.getElementsByTagName(tag);
    var classes = new Array();
    var length = allHTMLTags.length;
    for (var i=0; i < length; i++) {
        //multiple classes are in the same string, so search carefully
        if (allHTMLTags[i].className.indexOf(class) != -1) {
            classes.push(allHTMLTags[i]);
        }
    }
    return classes;
}

function placeSpambutton() {
    var button = document.createElement('input');
    button.setAttribute('type', 'button');
    button.setAttribute('name', 'toogle');
    button.setAttribute('value', bayesSpambutton);
    button.setAttribute('class', 'serendipityPrettyButton input_button');
    button.setAttribute('onclick', 'markAllSpam()');
    var existingButtons = document.getElementsByName('toggle');
    existingButtons[existingButtons.length - 1].parentNode.appendChild(button);
}

function markAllSpam() {
    var ids = getChecked();
    var length = ids.length;
    for (var i=0; i < length; i++) {
        spam(ids[i]);
    }
}

function getChecked() {
    var form = document.getElementById('formMultiDelete');
    var checkboxes = getElementByClass('input_checkbox', form, 'input');
    var length = checkboxes.length;
    for (var i=0; i < length; i++) {
        if (checkboxes[i].checked) {
           var id = checkboxes[i].name.split('[')[2];
           id = id.substr(0, id.length-1);
           spam(id);
        }
    }
}

addLoadEvent(getAllRatings);
addLoadEvent(placeSpambutton);
