<?php
if (IN_serendipity !== true) {
    die ("Don't hack!");
}

// Probe for a language include with constants. Still include defines later on, if some constants were missing
$probelang = dirname(__FILE__) . '/' . $serendipity['charset'] . 'lang_' . $serendipity['lang'] . '.inc.php';
if (file_exists($probelang)) {
    include $probelang;
}

include dirname(__FILE__) . '/lang_en.inc.php';

class serendipity_event_spamblock_bayes extends serendipity_event {
	var $lastRating;
	var $type = array(  'ip'        => 'IP',
                        'referrer'  => 'REFERRER',
	                    'email'      => 'MAIL',
	                    'url'       => 'URL',
	                    'body'      => 'BODY',
	                    'author'      => 'NAME'
	                    );
    var $path;
	                    
	function introspect(&$propbag) {
		global $serendipity;
		
		
		$this->title = PLUGIN_EVENT_SPAMBLOCK_BAYES_NAME;
		$propbag->add ( 'description', PLUGIN_EVENT_SPAMBLOCK_BAYES_DESC );
		$propbag->add ( 'name', $this->title );
		$propbag->add ( 'version', '0.3.2' );
		$propbag->add ( 'event_hooks', array ('frontend_saveComment' => true,
		                                     'backend_spamblock_comments_shown' => true,
		                                     'external_plugin' => true,
		                                     'backend_view_comment' => true,
		                                     'backend_comments_top' => true,
		                                     'backend_sendcomment' => true,
		                                     'backend_sidebar_entries' => true,
		                                     'backend_sidebar_entries_event_display_spamblock_bayes' => true
		                                     ));
		$propbag->add ( 'groups', array ('ANTISPAM' ) );
		$propbag->add ( 'author', 'kleinerChemiker,  Malte Paskuda, based upon b8 by Tobias Leupold');
		$propbag->add('configuration', array(
			'method',
			'moderateBarrier',
			'blockBarrier',
			'autolearn',
			'path',
			'logtype',
            'logfile',
            'menu',
            'recycler'
			));
	}
	
	
    function introspect_config_item($name, &$propbag)
    {
        global $serendipity;

        switch($name) {
            case 'method':
            	$propbag->add('type', 'select');
            	$propbag->add('name', PLUGIN_EVENT_SPAMBLOCK_METHOD);
            	$propbag->add('select_values', array(
            	                                    'moderate'   => PLUGIN_EVENT_SPAMBLOCK_BAYES_METHOD_MODERATE,
            	                                    'block'      => PLUGIN_EVENT_SPAMBLOCK_BAYES_METHOD_BLOCK,
            	                                    'custom'     => PLUGIN_EVENT_SPAMBLOCK_BAYES_METHOD_CUSTOM,
            	                                    ));
            	$propbag->add('default', 'moderation');
            	break;
            case 'moderateBarrier':
                $propbag->add('type', 'string');
                $propbag->add('name', PLUGIN_EVENT_SPAMBLOCK_BAYES_BARRIER_MODERATE);
                $propbag->add('description', PLUGIN_EVENT_SPAMBLOCK_BAYES_BARRIER_MODERATE_DESC);
                $propbag->add('default', 70);
                break;
            case 'blockBarrier':
                $propbag->add('type', 'string');
                $propbag->add('name', PLUGIN_EVENT_SPAMBLOCK_BAYES_BARRIER_BLOCK);
                $propbag->add('description', PLUGIN_EVENT_SPAMBLOCK_BAYES_BARRIER_BLOCK_DESC);
                $propbag->add('default', 90);
                break;
            case 'autolearn':
            	$propbag->add('type', 'boolean');
            	$propbag->add('name', PLUGIN_EVENT_SPAMBLOCK_BAYES_AUTOLEARN);
            	$propbag->add('description', PLUGIN_EVENT_SPAMBLOCK_BAYES_AUTOLEARN_DESC);
            	$propbag->add('default', false);
            	break;
            case 'menu':
            	$propbag->add('type', 'boolean');
            	$propbag->add('name', PLUGIN_EVENT_SPAMBLOCK_BAYES_MENU);
            	$propbag->add('description', PLUGIN_EVENT_SPAMBLOCK_BAYES_MENU_DESC);
            	$propbag->add('default', true);
            	break;
            case 'recycler':
            	$propbag->add('type', 'boolean');
            	$propbag->add('name', PLUGIN_EVENT_SPAMBLOCK_BAYES_MENU_RECYCLER);
            	$propbag->add('description', PLUGIN_EVENT_SPAMBLOCK_BAYES_RECYCLER_DESC);
            	$propbag->add('default', true);
            	break;
            case 'path':
                $propbag->add('type', 'string');
                $propbag->add('name', PLUGIN_EVENT_SPAMBLOCK_BAYES_PATH);
                $propbag->add('description', PLUGIN_EVENT_SPAMBLOCK_BAYES_PATH_DESC);
                $propbag->add('default', $serendipity['serendipityHTTPPath'] . 'plugins/serendipity_event_spamblock_bayes/');
                return true;
                break;
            case 'logfile':
                $propbag->add('type', 'string');
                $propbag->add('name', PLUGIN_EVENT_SPAMBLOCK_BAYES_LOGFILE);
                $propbag->add('description', PLUGIN_EVENT_SPAMBLOCK_BAYES_LOGFILE_DESC);
                $propbag->add('default', $serendipity['serendipityPath'] . 'spamblock-bayes.log');
                break;
            case 'logtype':
                $propbag->add('type', 'radio');
                $propbag->add('name', PLUGIN_EVENT_SPAMBLOCK_BAYES_LOGTYPE);
                $propbag->add('description', PLUGIN_EVENT_SPAMBLOCK_BAYES_LOGTYPE_DESC);
                $propbag->add('default', 'none');
                $propbag->add('radio',         array(
                    'value' => array('file', 'db', 'none'),
                    'desc'  => array(PLUGIN_EVENT_SPAMBLOCK_BAYES_LOGTYPE_FILE, PLUGIN_EVENT_SPAMBLOCK_BAYES_LOGTYPE_DB, PLUGIN_EVENT_SPAMBLOCK_BAYES_LOGTYPE_NONE)
                ));
                $propbag->add('radio_per_row', '1');
                break;
            default:
            	return false;
			}
		return true;
	}
	
	function generate_content(&$title) {
		$title = $this->title;
	}
	
	function install() {
		$this->setupDB ();
		$this->learnFromOld ();
	}
	
	function learnFromOld() {
	    global $serendipity;

		//approved comments are ham
		$sql = "SELECT
                    author,email,url,body,ip,referer
                FROM
                    {$serendipity['dbPrefix']}comments
                WHERE
                    status = 'approved'
                LIMIT 100;";
		$ham_comments = serendipity_db_query ( $sql );
		//learn via the spamblock-log what is spam:
		$sql = "SELECT
                    author,email,url,body,ip,referer
                FROM
                    {$serendipity['dbPrefix']}spamblocklog
                WHERE
                    type = 'REJECTED'
                LIMIT 100;";
		$spam_comments = serendipity_db_query ( $sql );
        if (is_array($ham_comments[0])) {
            foreach ($ham_comments as $comment) {
                $this->startLearn($comment, 'ham');
            }
        }
        if (is_array($spam_comments[0])) {
            foreach ($spam_comments as $comment) {
                $this->startLearn($comment, 'spam');
            }
        }
	}

    /*
    * get ratings of every part of the comment and combine
    * Wrapper for classify()
    */
	function startClassify($comment) {
	    $divider = 0;
	    $ratings = array();
	    $types = array('author', 'url', 'email', 'ip', 'body', 'referrer');
	    foreach($types as $type) {
            $rating = $this->classify($comment[$type], $this->type[$type]);
            if (is_numeric($rating)) {
                $ratings[] = $rating;
                $divider++;
            }
        }
        #catch division by zero which always occurs when nothing was learned
        if ($divider == 0) {
            $divider = 1;
        }
        if($this->get_config('method', 'moderate') == 'custom') {
            $spamBarrier = max(array(
                                $this->get_config('moderateBarrier', 70) / 100,
                                $this->get_config('blockBarrier', 90) / 100
                                ));
        } else {
            $spamBarrier = 0.9;
        }
        if(max($ratings) >= $spamBarrier) {
            return max($ratings);
        }
        
        return (array_sum($ratings) / $divider);
    }

    #Wrapper to call learn()
    function startLearn($comment, $category) {
        $this->learn($comment['author'], $category, $this->type['author']);
        $this->learn($comment['url'], $category, $this->type['url']);
        $this->learn($comment['email'], $category, $this->type['email']);
        $this->learn($comment['ip'], $category, $this->type['ip']);
        $this->learn($comment['body'], $category, $this->type['body']);
        $this->learn($comment['referrer'], $category, $this->type['referrer']);
    }

    
	/*
     * classify a string in the boundaries of 0 (ham) to 1 (spam)
     * */
	function classify($comment = '', $type) {
	    global $serendipity;
		$spam_texts = $this->get_config("{$type}_spam", 0);
		$ham_texts = $this->get_config("{$type}_ham", 0);

		if ($comment == '' && ! is_string ( $comment )) {
			return false;
		}
		if ($spam_texts == 0 || $ham_texts == 0) {
			return false;
		}

		if ($type == $this->type['ip']) {
            $tokens = array($comment => 1);
		} else {
		    $tokens = $this->tokenize($comment);
        }
		if ($tokens === false|| empty($tokens)) {
			return false;
		}
		$words = array_keys($tokens);
		foreach ($words AS $word) {
			$temp[] = '\'' . serendipity_db_escape_string($word) . '\'';
		}
		#Die gespeicherten Werte der Tokens aus DB holen
		$sql = 'SELECT token, ham, spam FROM ' . $serendipity ['dbPrefix'] . 'spamblock_bayes WHERE ' . serendipity_db_in_sql ( 'token', $temp ) .' AND type = \''. $type .'\'';
		unset ($temp);
		$stored_tokens = serendipity_db_query ( $sql, FALSE, 'assoc', FALSE, 'token' );
		foreach($tokens as $word => $count) {
			$word_count[$word] = $count;
			if (!isset($stored_tokens[$word])) {
				$rating = 1;
			} else if (empty($word)) {
			    continue;
            } else {
				$rating = ($stored_tokens[$word]['ham'] / $ham_texts) / (($stored_tokens[$word]['ham'] / $ham_texts) + ($stored_tokens[$word]['spam'] / $spam_texts));
			}

			$ratings[$word] = (0.15 + (($stored_tokens[$word]['ham'] + $stored_tokens[$word]['spam']) * $rating)) / (0.3 + $stored_tokens[$word]['ham'] + $stored_tokens[$word]['spam']);

			# Importance (distance to 0.5)
			$importance[$word] = abs(0.5 - $ratings[$word]);

		}

		//importance can be null if the comment don't contains real tokens
		//(like the smiley :) )
		if (is_array($importance)) {
		    arsort($importance);
		    reset($importance);
        }

        #number of important words
        $n = 0;
        $probability = 0;

        #calculate spamminness and hamminess
        #take only those important enough
        foreach($tokens as $word => $count) {
            if ($importance[$word] > 0.2) {
                $n++;
                $probability += $ratings[$word];
            }
        }
        
        if ( $n > 0 ) {
            $probability = $probability / $n;
        } else {
            $probability = 1;
        }
        return abs(1 - $probability);
	}
	
	/*
     * learn string as ham or spam
     * $text: string 
     * $category: string  (ham, spam)
     * $type: string (ip, body, ...)
     **/
	function learn($text, $group, $type) {
		global $serendipity;
		$this->setupDB();
		if ($group != 'ham' && $group != 'spam') {
			return FALSE;
		}
		if ($text == '' or ! is_string ($text)) {
			return FALSE;
		}
		#split text in tokens
		if ($type == $this->type['ip']) {
		    $tokens = array( $text => 1);
        } else {
            $tokens = $this->tokenize($text, $type);
        }
		$words = array_keys($tokens);
		
		foreach ($words AS $word) {
			$temp[] = '\'' . serendipity_db_escape_string($word) . '\'';
		}
		#get already saved value of tokens
		$sql = 'SELECT token, ' . $group . ' FROM ' . $serendipity ['dbPrefix'] . 'spamblock_bayes WHERE ' . serendipity_db_in_sql('token', $temp) . 'AND type = \'' . $type . '\' ';
		unset ($temp);
		$stored_values = serendipity_db_query ( $sql, FALSE, 'assoc', FALSE, 'token', $group );
		
		#Save new amount of all tokens
		foreach ($tokens as $token => $value) {
			if (isset ($stored_values [$token])) {
				$new_value [$token] = $stored_values [$token] + $value;
			} else {
				$new_value [$token] = -$value;
			}
		}
        
        foreach ($new_value as $token => $value) {
            if ($value > 0) {
                $sql = 'UPDATE ' . $serendipity ['dbPrefix'] . 'spamblock_bayes SET ' . $group . ' = ' . $value . ' WHERE token = \'' . $token . '\' AND type = \'' . $type . '\'';
            } else {
                $value = 1;
                $sql = 'INSERT INTO ' . $serendipity ['dbPrefix'] . 'spamblock_bayes (token, ' . $group . ', type) VALUES (\'' . $token . '\', \''. $value .'\', \'' . $type .'\')';
            }
            serendipity_db_query ($sql);
		}
		
		#Save amount of ham/spam
		$this->set_config("{$type}_{$group}", $this->get_config("{$type}_{$group}", 0) + 1);
		
		return true;
	}
	
	/*
     * Split text in words
     * param1: string $text
     * return: array Tokens
     **/
	function tokenize($text = '') {
		if ($text == '' or ! is_string($text)) {
			return false;
		}

        //preg_split won't accept e.g. Umlaute as part of \w
        mb_regex_encoding('UTF-8'); 
        $tokens = mb_split("\W", $text );
        #preg_match_all('/[\w]+/u', "aaaÂ´bbb", $words);

		$temp = array ();
		foreach ( $tokens as $token ) {
			if (isset ( $temp ["$token"] )) {
				$temp ["$token"] ++;
			} else {
				$temp ["$token"] = 1;
			}
		}
		#prevent the whitespaces to get saved in the database, they
		#would displace more important markers
		if (isset($temp[""])) {
            unset($temp[""]);
        }
		return $temp;
	}
    
	function getAmount($category, $type) {
	    global $serendipity;
        $sql = "SELECT $category FROM
                    {$serendipity['dbPrefix']}spamblock_bayes
                WHERE
                    type = '$type'";
        $ratings = serendipity_db_query($sql);
        $amount = 0;
        if (is_array($ratings)) {
            foreach($ratings as $rating) {
                $amount += $rating[0];
            }
        }
        return $amount;
    }
	
	/**
	 * initialize the db at first install or change after upgrade
	 * */
	function setupDB() {
	    global $serendipity;

        #main-table
		$sql = "CREATE TABLE {$serendipity['dbPrefix']}spamblock_bayes (
token VARCHAR(100) NOT NULL,
ham BIGINT UNSIGNED NOT NULL DEFAULT '0',
spam BIGINT UNSIGNED NOT NULL DEFAULT '0',
type VARCHAR(20) DEFAULT '{$this->type['body']}'
) {UTF_8}";
		serendipity_db_schema_import($sql);

        #recycler-table
        $sql = "CREATE TABLE
                {$serendipity['dbPrefix']}spamblock_bayes_recycler
                LIKE
                {$serendipity['dbPrefix']}comments";
        serendipity_db_query($sql);
		
        #when upgrading (to 0.3), type has to get added
        $dbversion = $this->get_config('dbversion', 1);
        if ($dbversion == '1') {
            $sql = "ALTER TABLE {$serendipity['dbPrefix']}spamblock_bayes
            ADD type VARCHAR(20) DEFAULT '{$this->type['body']}'";
            serendipity_db_query($sql);
            $sql = "ALTER TABLE {$serendipity['dbPrefix']}spamblock_bayes
            DROP {PRIMARY}";
            serendipity_db_schema_import($sql);

            $this->set_config('spam_' . $this->type['body'], $this->get_config('spam', 0));
            $this->set_config('ham_' . $this->type['body'], $this->get_config('ham', 0));
            $this->set_config('dbversion', 2);
        }
		
	}

    function deleteDB() {
        global $serendipity;
        $sql = "DROP TABLE
                {$serendipity['dbPrefix']}spamblock_bayes";
        serendipity_db_query($sql);
        foreach($this->type as $type) {
            $this->set_config("{$type}_ham", 0);
		    $this->set_config("{$type}_spam", 0);
        }
    }
	
	function checkIfSpam($comment) {
		$rating = $this->startClassify($comment);
		$this->lastRating = $rating;
		//a rating greater 0.8 is probably spam
		if ($rating >= 0.8) {
			$autolearn = $this->get_config('autolearn', false);
			if( ($rating > 0.9) && $autolearn)  {
                $this->startLearn($comment, 'spam');
			}
			return true;
		}
		return false;
	}
	
	function event_hook($event, &$bag, &$eventData, $addData = null) {
		global $serendipity;		
		$hooks = &$bag->get ( 'event_hooks' );
		
		if (isset ( $hooks [$event] )) {
			switch ($event) {
				case 'external_plugin' :
				    //catch learnAction here because the GET-Params prevent
				    //the normal switch/case to find this
				    if (strpos($eventData, 'learnAction') !== false) {
                        $this->learnAction($_REQUEST['id'], $_REQUEST['category'], $_REQUEST['action'], $_REQUEST['entry_id']);
                        return true;
                        break;
                    }
				    
					switch ($eventData) {
						case 'learncomment':
						    if (!serendipity_checkPermission('adminComments')) {
                                break;
                            }
							$category = $_REQUEST ['category'];
							$id = $_REQUEST ['id'];
							$comment = $this->getComment($id);
							if (is_array ($comment)) {
                                $comment = $comment['0'];
                                $entry_id = $comment['entry_id'];
		                    }

                            $this->startLearn($comment, $category);
							
							//Ham shall be approved, Spam deleted
                            if ($category == 'ham') {
                                serendipity_approveComment($id, $entry_id);
                            } elseif  ($category == 'spam') {
                                if($this->get_config('method', 'moderate') == 'custom') {
                                    $spamBarrier = min(array(
                                                        $this->get_config('moderateBarrier', 70) / 100,
                                                        $this->get_config('blockBarrier', 90) / 100
                                                        ));
                                } else {
                                    $spamBarrier = 0.7;
                                }
                                //spam shall not get through the filter twice - so make sure, it really is marked as spam
                                while ($this->startClassify($comment) < $spamBarrier) {
                                    $this->startLearn($comment, $category);
                                }
                                serendipity_deleteComment($id, $entry_id);
                            }
							break;
                        case 'spamblock_bayes.load.gif':
                            header('Content-Type: image/gif');
                            echo file_get_contents(dirname(__FILE__). '/img/spamblock_bayes.load.gif');
                            break;
                        case 'spamblock_bayes.spam.png':
                            header('Content-Type: image/png');
                            echo file_get_contents(dirname(__FILE__). '/img/spamblock_bayes.spam.png');
                            break;
                        case 'jquery.tablesorter.js':
                            header('Content-Type: text/javascript');
                            echo file_get_contents(dirname(__FILE__). '/jquery.tablesorter.js');
                            break;
                        case 'jquery.heatcolor.js':
                            header('Content-Type: text/javascript');
                            echo file_get_contents(dirname(__FILE__). '/jquery.heatcolor.js');
                            break;
                        case 'jquery.excerpt.js':
                            header('Content-Type: text/javascript');
                            echo file_get_contents(dirname(__FILE__). '/jquery.excerpt.js');
                            break; 
                        case 'serendipity_event_spamblock_bayes.js':
                            header('Content-Type: text/javascript');
                            echo file_get_contents(dirname(__FILE__). '/serendipity_event_spamblock_bayes.js');
                            break; 
                        case 'getRating':
                            $ids = $_REQUEST ['id'];
                            $ids = explode(';', $ids);

                            //we get the comments in wrong order
                            $comments = array_reverse($this->getComment($ids));
                            $i = 0;
                            foreach ($comments as $comment) {
                                $ratings .= preg_replace('/\..*/', '', $this->startClassify($comment) * 100) .'%;'. $ids[$i] . ';';
                                $i++;
                                
                            }
							echo $ratings;
							break;
                        case 'bayesMenuLearn':
                            if (!serendipity_checkPermission('adminComments')) {
                                break;
                            }
                            //the POST-Data of the form is almost exactly like the result of the database-query
                            $comment = $_POST;
                            //TODO: determine category
                            if (serendipity_db_bool($comment['ham'])) {
                                $category = 'ham';
                            } else {
                                $category = 'spam';
                            }
                            $this->startLearn($comment, $category);
                            
                            $redirect= '<meta http-equiv="REFRESH" content="0;url=';
                            $url = 'serendipity_admin.php?serendipity[adminModule]=event_display';
                            $url .= '&amp;serendipity[adminAction]=spamblock_bayes';
                            $url .= '&amp;serendipity[subpage]=1';
                            $url .= '&amp;serendipity[success]=Learned comment as '.$category.'">';
                            echo $redirect . $url;
                            break;
                        case 'bayesLearnFromOld':
                            if (!serendipity_checkPermission('adminComments')) {
                                break;
                            }
                            $this->learnFromOld();
                            #redirect the user back to the menu
                            $redirect= '<meta http-equiv="REFRESH" content="0;url=';
                            $url = 'serendipity_admin.php?serendipity[adminModule]=event_display';
                            $url .= '&amp;serendipity[adminAction]=spamblock_bayes';
                            $url .= '&amp;serendipity[subpage]=2';
                            $url .= '&amp;serendipity[success]=Learning Done">';
                            echo $redirect . $url;
                            break;
                        case 'bayesDeleteDatabase':
                            if (!serendipity_checkPermission('adminComments')) {
                                break;
                            }
                            $this->deleteDB();
                            $redirect= '<meta http-equiv="REFRESH" content="0;url=';
                            $url = 'serendipity_admin.php?serendipity[adminModule]=event_display';
                            $url .= '&amp;serendipity[adminAction]=spamblock_bayes';
                            $url .= '&amp;serendipity[subpage]=2';
                            $url .= '&amp;serendipity[success]=Database deleted">';
                            echo $redirect . $url;
                            break;
                        case 'bayesSetupDatabase':
                            if (!serendipity_checkPermission('adminComments')) {
                                break;
                            }
                            $this->setupDB();
                            $redirect= '<meta http-equiv="REFRESH" content="0;url=';
                            $url = 'serendipity_admin.php?serendipity[adminModule]=event_display';
                            $url .= '&amp;serendipity[adminAction]=spamblock_bayes';
                            $url .= '&amp;serendipity[subpage]=2';
                            $url .= '&amp;serendipity[success]=Database created">';
                            echo $redirect . $url;
                            break;
                        case 'bayesRecycler':
                            if (!serendipity_checkPermission('adminComments')) {
                                break;
                            }
                            if(isset($_REQUEST['restore'])) {
                                if ( !empty($_REQUEST['serendipity']['selected'])) {
                                    $ids = array_keys($_REQUEST['serendipity']['selected']);
                                    $this->restoreComments($ids);
                                    if (count($ids) > 1) {
                                        $msg = 'Comments '. implode(', ', $ids) .' restored';
                                    } else {
                                        $msg = 'Comment '. implode(', ', $ids) .' restored';
                                    }
                                    $msgtype = 'success';
                                } else {
                                    $msg = 'No comment selected';
                                    $msgtype = 'message';
                                }
                            }
                            if(isset($_REQUEST['empty'])) {
                                $this->emptyRecycler();
                                $msg = 'Recycler emptied';
                                $msgtype = 'success';
                            }
                            $redirect= '<meta http-equiv="REFRESH" content="0;url=';
                            $url = 'serendipity_admin.php?serendipity[adminModule]=event_display';
                            $url .= '&amp;serendipity[adminAction]=spamblock_bayes';
                            $url .= '&amp;serendipity[subpage]=3';
                            if ($msgtype == 'success') {
                                $url .= '&amp;serendipity[success]='. $msg .'">';
                            } else if ($msgtype == 'message') {
                                $url .= '&amp;serendipity[message]='. $msg .'">';
                            }
                            echo $redirect . $url;
                            break;
                            
					}
					return true;
					break;
					
				case 'frontend_saveComment' :
					if (! is_array ( $eventData ) || serendipity_db_bool ( $eventData ['allow_comments'] )) {
						$serendipity ['csuccess'] = 'true';
						$comment = array(   'url'       => $addData['url'],
						                    'body'      => $addData['comment'],
						                    'author'    => $addData['author'],
                                            'email'     => $addData['email'],
                                            'ip'        => $addData['ip'],
                                            'referrer'  => $addData['referrer']
                                            );
                        
                        if ($this->checkIfSpam($comment)) {
                            $method = $this->get_config('method', 'moderate');
                            if ($method == 'moderate') {
                                $this->moderate($eventData, $addData);
                                return false;
                            } elseif($method == 'block') {
                                $this->block($eventData, $addData);
                                return false;
                            }
                        }
                        $blockBarrier = $this->get_config('blockBarrier', 90) / 100;
                        $moderateBarrier = $this->get_config('moderateBarrier', 70) / 100;
                        //now this either wasn't spam or method custom is selected.
                        if ($this->lastRating > $blockBarrier) {
                            $this->block($eventData, $addData);
                            return false;
                        } elseif ($this->lastRating > $moderateBarrier) {
                            $this->moderate($eventData, $addData);
                            return false;
                        }
					}
					
					return true;
					break;

                case 'backend_view_comment':
                    $path = $this->path = $this->get_config('path', '');
                    if (!empty($path) && $path != 'default' && $path != 'none' && $path != 'empty') {
                        $path_defined = true;
                        $imgpath = $path . 'img/';
                    } else {
                        $path_defined = false;
                        $imgpath = $serendipity['baseURL'] . 'index.php?/plugin/';
                    }
                    $comment = &$eventData;
                    $eventData['action_more'] = '<a id="ham'. $comment ['id'] .'"
			class="serendipityIconLink spamblockBayesControls"
			onclick="ham('. $comment ['id'].')"
			title="'. PLUGIN_EVENT_SPAMBLOCK_BAYES_NAME . ': ' . PLUGIN_EVENT_SPAMBLOCK_BAYES_HAM .'"><img
			src="'. serendipity_getTemplateFile ( 'admin/img/accept.png' ) .'"
			alt="" />'. PLUGIN_EVENT_SPAMBLOCK_BAYES_HAM.'</a> <a
			id="spam'. $comment ['id'].'"
			class="serendipityIconLink spamblockBayesControls"
			onclick="spam('. $comment ['id'] .')"
			title="'. PLUGIN_EVENT_SPAMBLOCK_BAYES_NAME . ': ' . PLUGIN_EVENT_SPAMBLOCK_BAYES_SPAM .'"><img
			src="'. $imgpath . 'spamblock_bayes.spam.png' .'" 
			alt="" />'. PLUGIN_EVENT_SPAMBLOCK_BAYES_SPAM.'</a>';
                    return true;
                    break;

                case 'backend_sendcomment':
                    $delete = PLUGIN_EVENT_SPAMBLOCK_BAYES_DELETE . ': ';
                    $delete .= $serendipity['baseURL'] . 'index.php?/plugin/learnAction&action=delete&category=spam&id=' . $eventData['comment_id'] . '&entry_id='. $eventData['entry_id'];
                    $eventData['action_more']['delete'] = $delete;
                    if (!empty($eventData['moderate_comment']) && $eventData['moderate_comment']) {
                        $delete = PLUGIN_EVENT_SPAMBLOCK_BAYES_APPROVE . ': ';
                        $approve .= $serendipity['baseURL'] . 'index.php?/plugin/learnAction&action=approve&category=ham&id=' . $eventData['comment_id'] . '&entry_id='. $eventData['entry_id'];
                        $eventData['action_more']['approve'] = $approve;
                    }
                    return true;
                    break;

                case 'backend_comments_top':
                    $path = $this->path = $this->get_config('path', '');
                    if (!empty($path) && $path != 'default' && $path != 'none' && $path != 'empty') {
                        $path_defined = true;
                        $imgpath = $path . 'img/';
                    } else {
                        $path_defined = false;
                        $imgpath = $serendipity['baseURL'] . 'index.php?/plugin/';
                    }
                    echo "<style>
                        .spamblockBayesControls {
                            cursor: pointer;
                        }
                        .spamblockBayesRating {
                            float: right;
                        }
                        .spamblockBayesRating img {
                            vertical-align: middle;
                        }
                    </style>
                    <script>
                        var learncommentPath = '{$serendipity['baseURL']}index.php?/plugin/learncomment';
                        var ratingPath = '{$serendipity['baseURL']}index.php?/plugin/getRating';
                        var bayesCharset = '".LANG_CHARSET."';
                        var bayesDone = '".DONE."';
                        var bayesHelpImage = '".serendipity_getTemplateFile ('admin/img/admin_msg_note.png')."';
                        var bayesHelpTitle = '".PLUGIN_EVENT_SPAMBLOCK_BAYES_RATING_EXPLANATION."';
                        var bayesLoadIndicator = '{$imgpath}spamblock_bayes.load.gif';
                        var bayesSpambutton = '".PLUGIN_EVENT_SPAMBLOCK_BAYES_SPAMBUTTON."';
                    </script>
                    <script type=\"text/javascript\" src=\"{$path}bayes_commentlist.js\"></script>
                    ";
                    return true;
                    break;

                case 'backend_sidebar_entries':
                    if ($this->get_config('menu', true)) {
                        echo '<li class="serendipitySideBarMenuLink serendipitySideBarMenuEntryLinks">
                            <a href="?serendipity[adminModule]=event_display&serendipity[adminAction]=spamblock_bayes&serendipity[subpage]=1">
                                '. PLUGIN_EVENT_SPAMBLOCK_BAYES_NAME .'
                            </a>
                        </li>';
                    }
                    return true;
                    break;

                case 'backend_sidebar_entries_event_display_spamblock_bayes':
                    $path = $this->path = $this->get_config('path', '');
                    if (!empty($path) && $path != 'default' && $path != 'none' && $path != 'empty') {
                        $path_defined = true;
                        $imgpath = $path . 'img/';
                    } else {
                        $path_defined = false;
                        $imgpath = $serendipity['baseURL'] . 'index.php?/plugin/';
                    }
                    global $serendipity;
                    if (isset($serendipity['GET']['message'])) {
                        echo '<p class="serendipityAdminMsgNote">'.$serendipity['GET']['message'].'</p>';
                    }
                    if (isset($serendipity['GET']['success'])) {
                        echo '<p class="serendipityAdminMsgSuccess">'.$serendipity['GET']['success'].'</p>';
                    }
                    if (isset($serendipity['GET']['error'])) {
                        echo '<p class="serendipityAdminMsgError">'.$serendipity['GET']['error'].'</p>';
                    }
                    $this->displayMenu($serendipity['GET']['subpage']);
                    return true;
                    break;
				
				default :
					return false;
					break;
			}
		} else {
			return false;
		}
	}

    #Show the whole additional configuration, specifiy subpage for a specific tab
	function displayMenu($subpage=0) {
	    echo '<style>
        #bayesNav {
            margin: 0;
            padding: 0;
        }
        #bayesNav a {
            display: block;
        }
        #bayesNav li:last-child a {
            padding-right: 0.3em;
        }
        #bayesNav ul {
            list-style-type: none;
            margin: 0;
            padding: 0;
            border: 1px solid;
        }
        #bayesNav li {
            display: inline-block;
            margin: 0;
            padding: 0.5em;
            border-right: 1px solid;
        }
        #bayesNav h3 {
            display: inline;
            margin: 0;
            padding: 0;
            font-size: 1em;
        }
        #bayesLearnTable {
            padding-top: 1em;
        }
        #bayesLearnTable td {
            vertical-align: top;
        }
        #bayesControls {
            float: right;
            border: 1px solid;
            border-top: 0;
            -moz-border-radius-bottomleft: 5px;
            -webkit-border-bottom-left-radius: 5px;
            -moz-border-radius-bottomright: 5px;
            -webkit-border-bottom-right-radius: 5px;
            text-align: center;
        }
        #bayesControls input{
            margin: 0.5em;
            display: block;
        }
        #bayesControls input:first-child {
            margin-top: 1em;
            
        }
        #bayesDatabase {
            padding-top: 2em;
            margin-left: 2em;
        }
        #bayesSavedValues {
            padding-top: 2em;
        }
        #bayesDatabaseTable th {
            cursor: pointer;
            text-decoration: underline;
        }
        th {
            border: 1px solid;
        }
        caption {
            font-weight: bold;
        }
        #bayesSavedValuesTable td {
            text-align: center;
        }
        #bayesRecyclerTable {
            padding-top: 2em;
            padding-right: 2em;
        }
        #bayesRecyclerTable td {
            padding-top: 1em;
        }
	    </style>';
	    #add javascript for usability
	    echo '<script src="http://ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js" type="text/javascript"></script>
	    <script src="'.$this->path.'serendipity_event_spamblock_bayes.js" type="text/javascript"></script>';
	    #Navigation:
	    $menuNames = array( PLUGIN_EVENT_SPAMBLOCK_BAYES_MENU_LEARN,
	                        PLUGIN_EVENT_SPAMBLOCK_BAYES_MENU_DATABASE,
	                        PLUGIN_EVENT_SPAMBLOCK_BAYES_MENU_RECYCLER);
	    $menu ='<div id="bayesNav">
        <ul>';
        $menuLength = count($menuNames);
        for ($i=1; $i <= $menuLength; $i++) {
            if ($subpage == $i) {
                $menu .= '<li>
                 <h3><a href="?serendipity[adminModule]=event_display&serendipity[adminAction]=spamblock_bayes&serendipity[subpage]='.$i.'">
                  '. $menuNames[$i-1] .'
                </a></h3>
            </li>';
            } else {
                $menu .= '<li>
                 <a href="?serendipity[adminModule]=event_display&serendipity[adminAction]=spamblock_bayes&serendipity[subpage]='.$i.'">
                  '. $menuNames[$i-1] .'
                </a>
            </li>';
            }
        }
        echo $menu .'</ul>
	    </div>
	    
	    <div id="bayesContent">';
        switch($subpage) {
            case '1':
                $this->showLearnMenu();
                break;
            case '2':
                $this->showDBMenu();
                break;
            case '3':
                $this->showRecyclerMenu();
                break;
            default:
                break;
        }
        echo '</div>';
    }

    function showLearnMenu() {
        global $serendipity;

        echo '<form id="bayesLearnForm" action="'. "{$serendipity['baseURL']}index.php?/plugin/bayesMenuLearn" .'" method="post">
        <div id="bayesControls"><input type="submit" class="serendipityPrettyButton input_button" value="'.SAVE.'" name="submit"/></div>
        <table id="bayesLearnTable">
            <tr>
                <td><label for="bayesCommentName">'.NAME.'</label></td>
                <td><input type="text" id="bayesCommentName" name="author"></input></td>
            </tr>
        <tr>
                <td><label for="bayesCommentUrl">'.HOMEPAGE.'</label></td>
                <td>
        <input type="text" id="bayesCommentUrl" name="url"></input></td>
            </tr>
        <tr>
                <td><label for="bayesCommentEmail">'.EMAIL.'</label></td>
                <td>
        <input type="text" id="bayesCommentEmail" name="email"></input></td>
            </tr>
        <tr>
                <td><label for="bayesCommentIp">'.IP.'</label></td>
                <td>
        <input type="text" id="bayesCommentIp" name="ip"></input></td>
            </tr>
        <tr>
                <td><label for="bayesCommentReferrer">'.REFERER.'</label></td>
                <td>
        <input type="text" id="bayesCommentReferrer" name="referrer"></input></td>
            </tr>
        <tr>
                <td><label for="bayesCommentBody">'.COMMENT.'</label></td>
                <td>
        <textarea rows="10" cols="40" id="bayesCommentBody" name="body"></textarea></td>
            </tr>
        <tr>
                <td></td><td><label for="bayesCommentHam">'.PLUGIN_EVENT_SPAMBLOCK_BAYES_HAM.'</label>
        <input class="direction_ltr input_radio" type="radio" id="bayesCommentHam" name="ham" value="true" checked="" title="'.PLUGIN_EVENT_SPAMBLOCK_BAYES_HAM.'">
        <label for="bayesCommentSpam">'.PLUGIN_EVENT_SPAMBLOCK_BAYES_SPAM.'</label>
        <input class="direction_ltr input_radio" type="radio" id="bayesCommentSpam" name="ham" value="false" title="'.PLUGIN_EVENT_SPAMBLOCK_BAYES_SPAM.'"></td>
            </tr>
        </table>
        </form>';
    }

    function showDBMenu() {
        echo '
        <div id="bayesControls">
            <form action="'. "{$serendipity['baseURL']}index.php?/plugin/bayesSetupDatabase" .'" method="post">
                    <input type="submit" class="serendipityPrettyButton input_button" value="'.PLUGIN_EVENT_SPAMBLOCK_BAYES_CREATEDB.'" name="submit"/>
           </form>
            <form action="'. "{$serendipity['baseURL']}index.php?/plugin/bayesLearnFromOld" .'" method="post">
                    <input type="submit" class="serendipityPrettyButton input_button" value="'.PLUGIN_EVENT_SPAMBLOCK_BAYES_LEARNOLD.'" name="submit"/>
           </form>
            <form action="'. "{$serendipity['baseURL']}index.php?/plugin/bayesDeleteDatabase" .'" method="post">
                    <input type="submit" class="serendipityPrettyButton input_button" value="'.PLUGIN_EVENT_SPAMBLOCK_BAYES_ERASEDB.'" name="submit"/>
            </form>
        </div>';
        echo '<div id="bayesDatabase">'.
         $this->showTable('spamblock_bayes', false, PLUGIN_EVENT_SPAMBLOCK_BAYES_MENU_DATABASE, 'bayesDatabaseTable')
        . '</div>';
        echo '
        <div id="bayesSavedValues">
            <table id="bayesSavedValuesTable">
                <caption>'.PLUGIN_EVENT_SPAMBLOCK_BAYES_SAVEDVALUES.'</caption>';
        
        $thead .= '<thead>
                    <tr>';
        foreach($this->type as $type) {
            $thead .= '<th colspan="2">'.$type.'</th>';
        }
        $thead .= '</tr><tr>';
        foreach($this->type as $type) {
            $thead .= '<th>'.HAM.'</th>';
            $thead .= '<th>'.SPAM.'</th>';
        }
        $thead .= '</tr></thead>';
        $tbody = '<tbody><tr>';
        foreach($this->type as $type) {
            $tbody .='<td>'.$this->get_config("{$type}_ham", 0).'</td>';
		    $tbody .= '<td>'.$this->get_config("{$type}_spam", 0).'</td>';
        }
        $tbody .= '</tr></tbody>';
        echo "$thead $tbody </table></div>";
        echo '<script src="'.$this->path.'jquery.heatcolor.js" type="text/javascript"></script>
	    <script src="'.$this->path.'jquery.tablesorter.js" type="text/javascript"></script>
	    <script>$("#bayesDatabaseTable").tablesorter();
        sortwithcolor(2);</script>';
 
    }

    function showRecyclerMenu() {
        echo '<form action="'. "{$serendipity['baseURL']}index.php?/plugin/bayesRecycler" .'" method="post">
        <div id="bayesControls">
            <input type="submit" class="serendipityPrettyButton input_button" value="Restore" name="restore"/>
            <input type="submit" class="serendipityPrettyButton input_button" value="Empty Recycler" name="empty" />
        </div>'
        . $this->showTable('spamblock_bayes_recycler', true, '', 'bayesRecyclerTable', array('author', 'url', 'body', 'email'))
        .'</form>
        <script src="'.$this->path.'jquery.excerpt.js" type="text/javascript"></script>
        <script>shortenAll("body");</script>';
        
    }

    function showTable($table, $select=false, $caption="", $id="", $include="") {
        global $serendipity;
        $sql = "SELECT *
                FROM
                {$serendipity['dbPrefix']}$table
                ORDER BY 'id'
                LIMIT 0, 2000 ";
        $selectedTable = serendipity_db_query($sql);
        if ( empty($id)) {
            $output = '<table>';
        } else {
            $output = '<table id="'.$id.'">';
        }
        if ( ! empty($caption)) {
            $output .= "<caption>$caption</caption>";
        }
        if(is_array($selectedTable)) {
            //Generate a table-head with the real names, for detecting failed upgrades
            $output .= '<thead>
                    <tr>';
            $allNames = array_keys($selectedTable[0]);
            $name = array();
            if($select) {
                $output .= "<th>Restore?</th>";
            }
            foreach ($allNames as $name) {
                //have to filter the generic numbers in the arraykeys
                if (! is_numeric($name)) {
                    //and now let only those names pass which are in $include
                    if (is_array($include)) {
                        if ( ! in_array($name, $include)) {
                            continue;
                        }
                    } 
                    $output .= "<th>$name</th>";
                    $names[] = $name;
                        
                }
            }
            $output .= '</tr>
            </thead>';
            $output .= '<tbody>';
            foreach($selectedTable as $column) {
                $output .= '<tr>';
                if ($select) {
                    $output .= '<td><input type="checkbox" name="serendipity[selected]['.$column['id'].']" /></td>';
                }
                foreach ($names as $name) {
                    $output .= "<td class=\"$name\">{$column[$name]}</td>";
                }
                $output .= '</tr>';
            }
        } else {
            return;
        }
        
        $output .= '</tbody></table>';
        return $output;
    }

    #For email-notification. Learn a spam or ham and delete or approve.
	function learnAction($id, $category, $action, $entry_id) {
        if (!serendipity_checkPermission('adminComments')) {
            return;
        }
        $comment = $this->getComment($id);
        if (is_array ($comment)) {
            $comment = $comment['0'];
        }

        $this->startLearn($comment, $category);

        if ($action == 'delete') {
            serendipity_deleteComment($id, $entry_id);
        } else if ($action == 'approve') {
            serendipity_approveComment($id, $entry_id);
        }
    }

    #id: array of ids or a single id
	function getComment($id) {
        global $serendipity;

        if(is_array($id)) {
            $sql = "SELECT body, entry_id, author, email, url, ip, referer FROM {$serendipity['dbPrefix']}comments
                WHERE " . serendipity_db_in_sql ( 'id', $id );
        } else {
            $sql = "SELECT body, entry_id, author, email, url, ip, referer FROM {$serendipity['dbPrefix']}comments
                WHERE id = " . (int)$id;
        }
        return serendipity_db_query($sql);
    }

    function block(&$eventData, &$addData) {
        global $serendipity;
        if ($this->get_config('recycler', true)) {
            $this->throwInRecycler($eventData, $addData);
        }
        $logfile = $this->logfile = $this->get_config('logfile', $serendipity['serendipityPath'] . 'spamblock.log');
        $this->log($logfile, $eventData['id'], 'REJECTED', PLUGIN_EVENT_SPAMBLOCK_BAYES_REASON, $addData);
        $eventData = array ('allow_comments' => false);
        $serendipity ['messagestack'] ['comments'] [] = PLUGIN_EVENT_SPAMBLOCK_BAYES_ERROR;
    }

    function moderate(&$eventData, &$addData) {
        global $serendipity;
        $logfile = $this->logfile = $this->get_config('logfile', $serendipity['serendipityPath'] . 'spamblock.log');
        $this->log($logfile, $eventData['id'], 'MODERATE', PLUGIN_EVENT_SPAMBLOCK_BAYES_REASON, $addData);
        $eventData['moderate_comments'] = true;
        $serendipity['csuccess']        = 'moderate';
        $serendipity['moderate_reason'] = sprintf(PLUGIN_EVENT_SPAMBLOCK_BAYES_MODERATE);
    }

    //Empty the Recycler
    function emptyRecycler() {
        global $serendipity;
        $sql = "DELETE FROM
                {$serendipity['dbPrefix']}spamblock_bayes_recycler";
        serendipity_db_query($sql);        
    }

    //Get the blocked comment and store it in the recycler-table
    function throwInRecycler(&$ca, &$commentInfo) {
        global $serendipity;

        #code copied from serendipity_insertComment. Changed: $id and $status
        $id            = (int)$ca['id'];
        $type          = $commentInfo['type'];
        if (isset($commentInfo['subscribe'])) {
            if (!isset($serendipity['allowSubscriptionsOptIn']) || $serendipity['allowSubscriptionsOptIn']) {
                $subscribe = 'false';
            } else {
                $subscribe = 'true';
            }
        } else {
            $subscribe = 'false';
        }
        //'approved' cause only relevant after recovery
        $dbstatus = 'approved';
            
        $title         = serendipity_db_escape_string($ca['title']);
        $comments      = $commentInfo['comment'];
        $ip            = serendipity_db_escape_string(isset($commentInfo['ip']) ? $commentInfo['ip'] : $_SERVER['REMOTE_ADDR']);
        $commentsFixed = serendipity_db_escape_string($commentInfo['comment']);
        $name          = serendipity_db_escape_string($commentInfo['name']);
        $url           = serendipity_db_escape_string($commentInfo['url']);
        $email         = serendipity_db_escape_string($commentInfo['email']);
        $parentid      = (isset($commentInfo['parent_id']) && is_numeric($commentInfo['parent_id'])) ? $commentInfo['parent_id'] : 0;
        $status        = serendipity_db_escape_string(isset($commentInfo['status']) ? $commentInfo['status'] : (serendipity_db_bool($ca['moderate_comments']) ? 'pending' : 'approved'));
        $t             = serendipity_db_escape_string(isset($commentInfo['time']) ? $commentInfo['time'] : time());
        $referer       = substr((isset($_SESSION['HTTP_REFERER']) ? serendipity_db_escape_string($_SESSION['HTTP_REFERER']) : ''), 0, 200);
        
        $sql  = "INSERT INTO
                    {$serendipity['dbPrefix']}spamblock_bayes_recycler (entry_id, parent_id, ip, author, email, url, body, type, timestamp, title, subscribed, status, referer)
                    VALUES ('$id', '$parentid', '$ip', '$name', '$email', '$url', '$commentsFixed', '$type', '$t', '$title', '$subscribe', '$dbstatus', '$referer')";

        serendipity_db_query($sql);
    }

    function restoreComments($ids) {
        global $serendipity;
        if (is_array($ids)) {
            $sql = "INSERT INTO
                    {$serendipity['dbPrefix']}comments
                    (entry_id, parent_id, ip, author, email, url, body, type, timestamp, title, subscribed, status, referer)
                    SELECT
                    entry_id, parent_id, ip, author, email, url, body, type, timestamp, title, subscribed, status, referer
                    FROM
                    {$serendipity['dbPrefix']}spamblock_bayes_recycler
                    WHERE " . serendipity_db_in_sql ( 'id', $ids );
        } else {
            $sql = "INSERT INTO
                    {$serendipity['dbPrefix']}comments
                    (entry_id, parent_id, ip, author, email, url, body, type, timestamp, title, subscribed, status, referer)
                    SELECT
                    entry_id, parent_id, ip, author, email, url, body, type, timestamp, title, subscribed, status, referer
                    FROM
                    {$serendipity['dbPrefix']}spamblock_bayes_recycler
                    WHERE id = " . (int)$ids;
        }
        serendipity_db_query($sql);
        $this->deleteFromRecycler($ids);
    }

    function deleteFromRecycler($ids) {
        global $serendipity;
        if (is_array($ids)) {
            $sql = "DELETE FROM
                    {$serendipity['dbPrefix']}spamblock_bayes_recycler
                    WHERE " . serendipity_db_in_sql ( 'id', $ids );
        } else {
            $sql = "DELETE FROM
                    {$serendipity['dbPrefix']}spamblock_bayes_recycler
                    WHERE id = " . (int)$ids;
        }
        serendipity_db_query($sql);
    }
	
	function debugMsg($msg) {
		global $serendipity;
		
		$this->debug_fp = @fopen ( $serendipity ['serendipityPath'] . 'templates_c/spamblock_bayes.log', 'a' );
		if (! $this->debug_fp) {
			return false;
		}
		
		if (empty ( $msg )) {
			fwrite ( $this->debug_fp, "failure \n" );
		} else {
			fwrite ( $this->debug_fp, print_r ( $msg, true ) );
		}
		fclose ( $this->debug_fp );
	}
	
	function log($logfile, $id, $switch, $reason, $comment) {
        global $serendipity;
        $method = $this->get_config('logtype');

        switch($method) {
            case 'file':
            	
                if (empty($logfile)) {
                    return;
                }
				if (strpos($logfile, '%') !== false) {
					$logfile = strftime($logfile);
				}

                $fp = @fopen($logfile, 'a+');
                if (!is_resource($fp)) {
                    return;
                }
                fwrite($fp, sprintf(
                    '[%s] - [%s: %s] - [#%s, Name "%s", E-Mail "%s", URL "%s", User-Agent "%s", IP %s] - [%s]' . "\n",
                    date('Y-m-d H:i:s', serendipity_serverOffsetHour()),
                    $switch,
                    $reason,
                    $id,
                    str_replace("\n", ' ', $comment['name']),
                    str_replace("\n", ' ', $comment['email']),
                    str_replace("\n", ' ', $comment['url']),
                    str_replace("\n", ' ', $_SERVER['HTTP_USER_AGENT']),
                    $_SERVER['REMOTE_ADDR'],
                    str_replace("\n", ' ', $comment['comment'])
                ));

                fclose($fp);
                break;

            case 'none':
                return;
                break;

            case 'db':
            default:
                $q = sprintf("INSERT INTO {$serendipity['dbPrefix']}spamblocklog
                                          (timestamp, type, reason, entry_id, author, email, url,  useragent, ip,   referer, body)
                                   VALUES (%d,        '%s',  '%s',  '%s',     '%s',   '%s',  '%s', '%s',      '%s', '%s',    '%s')",

                           serendipity_serverOffsetHour(),
                           serendipity_db_escape_string($switch),
                           serendipity_db_escape_string($reason),
                           serendipity_db_escape_string($id),
                           serendipity_db_escape_string($comment['name']),
                           serendipity_db_escape_string($comment['email']),
                           serendipity_db_escape_string($comment['url']),
                           substr(serendipity_db_escape_string($_SERVER['HTTP_USER_AGENT']), 0, 255),
                           serendipity_db_escape_string($_SERVER['REMOTE_ADDR']),
                           substr(serendipity_db_escape_string(isset($_SESSION['HTTP_REFERER']) ? $_SESSION['HTTP_REFERER'] : $_SERVER['HTTP_REFERER']), 0, 255),
                           serendipity_db_escape_string($comment['comment'])
                );

                serendipity_db_schema_import($q);
                break;
        }
    }
}
